/* ---- memory allocation ---- */


#include <stdlib.h>
#include <stdio.h>

// ONE-D memory routines
int *alloc_1d_int(int n1);
void free_1d_int(int *i);

float *alloc_1d_float(int n1);
void free_1d_float(float *d);

double *alloc_1d_double(int n1);
void free_1d_double(double *d);


// TWO-D memory routines
int **alloc_2d_int(int n1, int n2);
void free_2d_int(int **ii);

float **alloc_2d_float(int n1, int n2);
void free_2d_float(float **dd);

double **alloc_2d_double(int n1, int n2);
void free_2d_double(double **dd);


// THREE-D memory routines
int ***alloc_3d_int(int n1, int n2, int n3);
void free_3d_int(int ***iii);

float ***alloc_3d_float(int n1, int n2, int n3);
void free_3d_float(float ***ddd);

double ***alloc_3d_double(int n1, int n2, int n3);
void free_3d_double(double ***ddd);

#define alloc_error_check(p) { \
    if ((p) == NULL) { \
        fprintf(stderr, "Allocation Failure!\n"); \
        exit(1); \
    } \
}
