#define OOURA_MAX(x,y) ((x) > (y) ? (x) : (y))

/* random number generator, 0 <= RND < 1 */
#define OOURA_RND(p) ((*(p) = (*(p) * 7141 + 54773) % 259200) * (1.0 / 259200))


void cdft2d(int, int, int, double **, int *, double *);
void rdft2d(int, int, int, double **, int *, double *);
void rdft2d_f(int, int, int, float **, int *, float *);
void ddct2d(int, int, int, double **, double *, int *, double *);
void ddst2d(int, int, int, double **, double *, int *, double *);

void putdata2d(int n1, int n2, double **a);
double errorcheck2d(int n1, int n2, double scale, double **a);

void putdata2d_f(int n1, int n2, float **a);
float errorcheck2d_f(int n1, int n2, float scale, float **a);

//float helper functions
    void makewt_f(int nw, int *ip, float *w);
    void makect_f(int nc, int *ip, float *c);
    void bitrv2col_f(int n1, int n, int *ip, float **a);
    void bitrv2row_f(int n, int n2, int *ip, float **a);
    void cftbcol_f(int n1, int n, float **a, float *w);
    void cftbrow_f(int n, int n2, float **a, float *w);
    void cftfcol_f(int n1, int n, float **a, float *w);
    void cftfrow_f(int n, int n2, float **a, float *w);
    void rftbcol_f(int n1, int n, float **a, int nc, float *c);
    void rftfcol_f(int n1, int n, float **a, int nc, float *c);

//double helper functions
    void makewt(int nw, int *ip, double *w);
    void bitrv2col(int n1, int n, int *ip, double **a);
    void bitrv2row(int n, int n2, int *ip, double **a);
    void cftbcol(int n1, int n, double **a, double *w);
    void cftbrow(int n, int n2, double **a, double *w);
    void cftfcol(int n1, int n, double **a, double *w);
    void cftfrow(int n, int n2, double **a, double *w);
