#ifndef COLLIER_CSC583LIB_H
#define COLLIER_CSC583LIB_H

using namespace csc583Base;

//
// Image processing libray header written by Wiehrs Lewis Collier
// for URI CSC583 Spring 2005

//
// #defines // prefix "k" e.g. kDefinedVar
//             prefix "g" e.g. gDefinedVar for flags (2**n)
//

// famous values
#define kWLC_Null			0

// function return values
#define gWLC_Success		0
#define gWLC_Failure		1
#define gWLC_BadArgument	2
#define gWLC_BadPtr			4


// misc parameter defines
#define gWLC_Equal	 			1
#define gWLC_LessThan 			2
#define gWLC_LessThanEqual		(gWLC_LessThan|gWLC_Equal) // 3
#define gWLC_GreaterThan		4
#define gWLC_GreaterThanEqual 	(gWLC_GreaterThan|gWLC_Equal) // 5
#define gWLC_NotEqual	 		(gWLC_LessThan|gWLC_GreaterThan) // 6


#define	kWLC_8bits			1
#define	kWLC_16Bits			2
#define	kWLC_24bits			3
#define	kWLC_32bits			4


// Valid pointer check (for now just check for NULL) useless but quick and dirty
#define kWLC_InvalidPtr(ptr) 	((ptr==kWLC_Null)?1:0)
#define kWLC_ValidPtr(ptr) 		(!kWLC_InvalidPtr(ptr))

#define kWLC_IsOdd(n)			(((((n)/2)*2)==(n))?0:1)
#define kWLC_IsEven(n)			(((((n)/2)*2)==(n))?1:0)

#define kWLC_Max(a,b)			( ((a)>=(b))?(a):(b))
#define kWLC_Min(a,b)			( ((a)<=(b))?(a):(b))

// typedefs for functions just to be safe
typedef signed char			WLC_byte;	// prefix "b" e.g. bVar (8 bit integer)
typedef unsigned char 		WLC_ubyte;	// prefix "ub" e.g. ubVar (unsigned)

typedef signed short int	WLC_word;	// prefix "w" e.g. wVar (16 bit integer)
typedef unsigned short int	WLC_uword;	// prefix "uw" e.g. uwVar (unsigned)

typedef signed int	 		WLC_int;	// prefix "n" e.g. nVar (32 bit int)
typedef unsigned int		WLC_uint;	// prefix "un" e.g. unVar (unsigned)

typedef signed long int		WLC_long;	// prefix "l" e.g. lVar (64 bit int)
typedef unsigned long int	WLC_ulong;	// prefix "ul" e.g. ulVar (unsigned)

typedef float 				WLC_float;	// prefix "f" e.g. fVar (single precision)
typedef double				WLC_double;	// prefix "d" e.g. dVar (double precision)

typedef unsigned char 	   *WLC_string;	// prefix "psz" e.g. pszVar

typedef long 			    WLC_status;	// postfix "Status" e.g. FuncStatus


bool IsPowerOf2(int n);


void SwapEndian4(void *a, void *b);
void SwapEndian2(void *a, void *b);


/********************************************************************
**
** Copyright (c) 1989 Mark R. Nelson
**
** LZW data compression/expansion demonstration program.
**
** April 13, 1989
**
*****************************************************************************/
#define BITS 12                   /* Setting the number of bits to 12, 13*/
#define HASHING_SHIFT BITS-8      /* or 14 affects several constants.    */
#define MAX_VALUE (1 << BITS) - 1 /* Note that MS-DOS machines need to   */
#define MAX_CODE MAX_VALUE - 1    /* compile their code in large model if*/
                                  /* 14 bits are selected.               */
#if BITS == 14
  #define TABLE_SIZE 18041        /* The string table size needs to be a */
#endif                            /* prime number that is somewhat larger*/
#if BITS == 13                    /* than 2**BITS.                       */
  #define TABLE_SIZE 9029
#endif
#if BITS <= 12
  #define TABLE_SIZE 5021
#endif

#endif  //  COLLIER_CSC583LIB_H